template <class D, class P>
int TorqueGeneratedArrayBoilerplateDescription<D, P>::flags() const {
  int value;
  value = TaggedField<Smi>::load(*this, kFlagsOffset).value();
  return value;
}
template <class D, class P>
void TorqueGeneratedArrayBoilerplateDescription<D, P>::set_flags(int value) {
  WRITE_FIELD(*this, kFlagsOffset, Smi::FromInt(value));
}

template <class D, class P>
FixedArrayBase TorqueGeneratedArrayBoilerplateDescription<D, P>::constant_elements() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedArrayBoilerplateDescription::constant_elements(isolate);
}
template <class D, class P>
FixedArrayBase TorqueGeneratedArrayBoilerplateDescription<D, P>::constant_elements(IsolateRoot isolate) const {
  FixedArrayBase value;
  value = TaggedField<FixedArrayBase>::load(isolate, *this, kConstantElementsOffset);
  DCHECK(value.IsFixedArrayBase());
  return value;
}
template <class D, class P>
void TorqueGeneratedArrayBoilerplateDescription<D, P>::set_constant_elements(FixedArrayBase value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsFixedArrayBase());
  WRITE_FIELD(*this, kConstantElementsOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kConstantElementsOffset, value, mode);
}

template<class D, class P>
inline TorqueGeneratedArrayBoilerplateDescription<D, P>::TorqueGeneratedArrayBoilerplateDescription(Address ptr)
  : P(ptr) {
  SLOW_DCHECK(IsArrayBoilerplateDescription_NonInline(*this));
}
template<class D, class P>
inline TorqueGeneratedArrayBoilerplateDescription<D, P>::TorqueGeneratedArrayBoilerplateDescription(Address ptr, HeapObject::AllowInlineSmiStorage allow_smi)
  : P(ptr, allow_smi) {
  SLOW_DCHECK((allow_smi == HeapObject::AllowInlineSmiStorage::kAllowBeingASmi && this->IsSmi()) || IsArrayBoilerplateDescription_NonInline(*this));
}
template <class D, class P>
FixedArray TorqueGeneratedRegExpBoilerplateDescription<D, P>::data() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedRegExpBoilerplateDescription::data(isolate);
}
template <class D, class P>
FixedArray TorqueGeneratedRegExpBoilerplateDescription<D, P>::data(IsolateRoot isolate) const {
  FixedArray value;
  value = TaggedField<FixedArray>::load(isolate, *this, kDataOffset);
  DCHECK(value.IsFixedArray());
  return value;
}
template <class D, class P>
void TorqueGeneratedRegExpBoilerplateDescription<D, P>::set_data(FixedArray value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsFixedArray());
  WRITE_FIELD(*this, kDataOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kDataOffset, value, mode);
}

template <class D, class P>
String TorqueGeneratedRegExpBoilerplateDescription<D, P>::source() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedRegExpBoilerplateDescription::source(isolate);
}
template <class D, class P>
String TorqueGeneratedRegExpBoilerplateDescription<D, P>::source(IsolateRoot isolate) const {
  String value;
  value = TaggedField<String>::load(isolate, *this, kSourceOffset);
  DCHECK(value.IsString());
  return value;
}
template <class D, class P>
void TorqueGeneratedRegExpBoilerplateDescription<D, P>::set_source(String value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsString());
  WRITE_FIELD(*this, kSourceOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kSourceOffset, value, mode);
}

template <class D, class P>
int TorqueGeneratedRegExpBoilerplateDescription<D, P>::flags() const {
  int value;
  value = TaggedField<Smi>::load(*this, kFlagsOffset).value();
  return value;
}
template <class D, class P>
void TorqueGeneratedRegExpBoilerplateDescription<D, P>::set_flags(int value) {
  WRITE_FIELD(*this, kFlagsOffset, Smi::FromInt(value));
}

template<class D, class P>
inline TorqueGeneratedRegExpBoilerplateDescription<D, P>::TorqueGeneratedRegExpBoilerplateDescription(Address ptr)
  : P(ptr) {
  SLOW_DCHECK(IsRegExpBoilerplateDescription_NonInline(*this));
}
template<class D, class P>
inline TorqueGeneratedRegExpBoilerplateDescription<D, P>::TorqueGeneratedRegExpBoilerplateDescription(Address ptr, HeapObject::AllowInlineSmiStorage allow_smi)
  : P(ptr, allow_smi) {
  SLOW_DCHECK((allow_smi == HeapObject::AllowInlineSmiStorage::kAllowBeingASmi && this->IsSmi()) || IsRegExpBoilerplateDescription_NonInline(*this));
}
