template <class D, class P>
Object TorqueGeneratedStackFrameInfo<D, P>::receiver_or_instance() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedStackFrameInfo::receiver_or_instance(isolate);
}
template <class D, class P>
Object TorqueGeneratedStackFrameInfo<D, P>::receiver_or_instance(IsolateRoot isolate) const {
  Object value;
  value = TaggedField<Object>::load(isolate, *this, kReceiverOrInstanceOffset);
  DCHECK(value.IsJSReceiver() || value.IsSmi() || value.IsHeapNumber() || value.IsBigInt() || value.IsString() || value.IsSymbol() || value.IsTrue() || value.IsFalse() || value.IsNull() || value.IsUndefined());
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_receiver_or_instance(Object value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsJSReceiver() || value.IsSmi() || value.IsHeapNumber() || value.IsBigInt() || value.IsString() || value.IsSymbol() || value.IsTrue() || value.IsFalse() || value.IsNull() || value.IsUndefined());
  WRITE_FIELD(*this, kReceiverOrInstanceOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kReceiverOrInstanceOffset, value, mode);
}

template <class D, class P>
Object TorqueGeneratedStackFrameInfo<D, P>::function() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedStackFrameInfo::function(isolate);
}
template <class D, class P>
Object TorqueGeneratedStackFrameInfo<D, P>::function(IsolateRoot isolate) const {
  Object value;
  value = TaggedField<Object>::load(isolate, *this, kFunctionOffset);
  DCHECK(value.IsSmi() || value.IsJSFunction());
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_function(Object value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsSmi() || value.IsJSFunction());
  WRITE_FIELD(*this, kFunctionOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kFunctionOffset, value, mode);
}

template <class D, class P>
HeapObject TorqueGeneratedStackFrameInfo<D, P>::code_object() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedStackFrameInfo::code_object(isolate);
}
template <class D, class P>
HeapObject TorqueGeneratedStackFrameInfo<D, P>::code_object(IsolateRoot isolate) const {
  HeapObject value;
  value = TaggedField<HeapObject>::load(isolate, *this, kCodeObjectOffset);
  DCHECK(value.IsHeapObject());
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_code_object(HeapObject value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsHeapObject());
  WRITE_FIELD(*this, kCodeObjectOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kCodeObjectOffset, value, mode);
}

template <class D, class P>
int TorqueGeneratedStackFrameInfo<D, P>::code_offset_or_source_position() const {
  int value;
  value = TaggedField<Smi>::load(*this, kCodeOffsetOrSourcePositionOffset).value();
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_code_offset_or_source_position(int value) {
  WRITE_FIELD(*this, kCodeOffsetOrSourcePositionOffset, Smi::FromInt(value));
}

template <class D, class P>
int TorqueGeneratedStackFrameInfo<D, P>::flags() const {
  int value;
  value = TaggedField<Smi>::load(*this, kFlagsOffset).value();
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_flags(int value) {
  WRITE_FIELD(*this, kFlagsOffset, Smi::FromInt(value));
}

template <class D, class P>
FixedArray TorqueGeneratedStackFrameInfo<D, P>::parameters() const {
  IsolateRoot isolate = GetIsolateForPtrCompr(*this);
  return TorqueGeneratedStackFrameInfo::parameters(isolate);
}
template <class D, class P>
FixedArray TorqueGeneratedStackFrameInfo<D, P>::parameters(IsolateRoot isolate) const {
  FixedArray value;
  value = TaggedField<FixedArray>::load(isolate, *this, kParametersOffset);
  DCHECK(value.IsFixedArray());
  return value;
}
template <class D, class P>
void TorqueGeneratedStackFrameInfo<D, P>::set_parameters(FixedArray value, WriteBarrierMode mode) {
  SLOW_DCHECK(value.IsFixedArray());
  WRITE_FIELD(*this, kParametersOffset, value);
  CONDITIONAL_WRITE_BARRIER(*this, kParametersOffset, value, mode);
}

template<class D, class P>
inline TorqueGeneratedStackFrameInfo<D, P>::TorqueGeneratedStackFrameInfo(Address ptr)
  : P(ptr) {
  SLOW_DCHECK(IsStackFrameInfo_NonInline(*this));
}
template<class D, class P>
inline TorqueGeneratedStackFrameInfo<D, P>::TorqueGeneratedStackFrameInfo(Address ptr, HeapObject::AllowInlineSmiStorage allow_smi)
  : P(ptr, allow_smi) {
  SLOW_DCHECK((allow_smi == HeapObject::AllowInlineSmiStorage::kAllowBeingASmi && this->IsSmi()) || IsStackFrameInfo_NonInline(*this));
}
